diff -bruN freeswan-1.9.orig/pluto/xmap_ldap.h freeswan-1.9/pluto/xmap_ldap.h
--- freeswan-1.9.orig/pluto/xmap_ldap.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/xmap_ldap.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,49 @@
+#ifndef XMAP_LDAP_H
+#define XMAP_LDAP_H
+
+#ifdef HAVE_LDAP
+
+#include <openssl/safestack.h>
+#include <openssl/x509.h>
+
+#include <lber.h>
+#include <ldap.h>
+
+#include "x_sobj.h"
+#include "xmap.h"
+
+typedef struct _flist_st {
+  char *index;
+  int type;
+  char *filter;
+} flist;
+
+#define MAXFLIST 10
+
+typedef struct _alist_st {
+  char *index;
+  int type;
+  char **attrs;
+} alist;
+
+typedef struct xmap_ldap_st {
+  char *ldapsource;
+  char *ldap_host;
+  int ldap_port;
+  char *ldap_base;
+  int ldap_timeout;
+  char *ldap_bindDN;
+  char *ldap_bindPW;
+  flist ldap_filter[MAXFLIST];
+  alist ldap_attrs[MAXFLIST];
+
+  LDAP *ld;
+
+  XMAP_METHOD *meth;
+} XMAP_LDAP;
+
+XMAP_METHOD *XMAP_METHOD_ldap( void );
+
+#endif /* HAVE_LDAP */
+
+#endif /* XMAP_LDAP_H */
diff -bruN freeswan-1.9.orig/utils/Makefile freeswan-1.9/utils/Makefile
--- freeswan-1.9.orig/utils/Makefile	Tue Feb  6 13:11:41 2001
+++ freeswan-1.9/utils/Makefile	Thu Jun  7 14:52:06 2001
@@ -17,16 +17,24 @@
 PUBDIR=/usr/local/sbin
 PRIVDIR=/usr/local/lib/ipsec
 REALPRIVDIR=/usr/local/lib/ipsec
+FINALPRIVDIR=/usr/local/lib/ipsec
 RCDIR=/etc/rc.d/init.d
 REALRCDIR=/etc/rc.d/init.d
 CONFDIR=/etc
-MANTREE=/usr/local/man
+MANTREE=/usr/man
 
 FMANDIR=$(MANTREE)/man5
 CMANDIR=$(MANTREE)/man8
 PUBS=ipsec
-BINS=ranbits rsasigkey
+
+ifeq "$(USEOPENSSL)" "1"
+SCRIPTS=barf manual auto look showdefaults showhostkey rehashcertdir rsakeygen updown.firewall
+BINS=ranbits rsasigkey fswcert
+else
 SCRIPTS=barf manual auto look showdefaults showhostkey
+BINS=ranbits rsasigkey
+endif
+
 INTERNALS=_include _confread _keycensor _secretcensor _updown
 PRIVS=$(PUBS) $(SCRIPTS) $(INTERNALS) $(BINS)
 GENDFILES=secrets.eg conf.eg
@@ -47,6 +55,10 @@
 
 all:	$(PUBS) $(PRIVS) $(GENDFILES) $(LOCALS)
 
+fswcert: fswcert-0.4/fswcert.c
+	cd fswcert-0.4; $(MAKE)
+	cp fswcert-0.4/fswcert .
+
 ranbits:	ranbits.o
 	$(CC) $(CFLAGS) ranbits.o $(LIB) -o $@
 
@@ -64,7 +76,7 @@
 
 ipsec:	ipsec.in
 	VER=`sed -n '/"/s/^[^"]*"//p' ../version.c | sed 's/".*//'` ; \
-	sed "s/xxx/$$VER/" ipsec.in | sed "s:@IPSECDIR@:$(REALPRIVDIR):" >$@
+	sed "s/xxx/$$VER/" ipsec.in | sed "s:@IPSEC_DIR@:$(REALPRIVDIR):" >$@
 	chmod +x $@
 
 # generate sample secret (obfuscating it so that people don't get confused
@@ -98,41 +110,46 @@
 	./randomize conf.proto | egrep -v RCSI >$@
 
 install:	$(PUBS) $(PRIVS) $(MANS) $(GENDFILES)
-	mkdir -p $(PUBDIR) $(PRIVDIR) $(FMANDIR) $(CMANDIR) $(CONFDIR)
-	$(INSTALL) $(PUBS) $(PUBDIR)
-	$(INSTALL) $(PRIVS) $(PRIVDIR)
-	$(INSTALL) $(PUB) ipsec.conf.5 $(FMANDIR)
-	$(INSTALL) $(PUB) $(PLAIN_MANS) $(CMANDIR)
+	mkdir -p $(PREFIX)/$(PUBDIR) $(PREFIX)/$(PRIVDIR) 
+	mkdir -p $(PREFIX)/$(FMANDIR) $(PREFIX)/$(CMANDIR) 
+	mkdir -p $(PREFIX)/$(CONFDIR)
+	$(INSTALL) $(PUBS) $(PREFIX)/$(PUBDIR)
+	$(INSTALL) $(PRIVS) $(PREFIX)/$(PRIVDIR)
+	$(INSTALL) $(PUB) ipsec.conf.5 $(PREFIX)/$(FMANDIR)
+	$(INSTALL) $(PUB) $(PLAIN_MANS) $(PREFIX)/$(CMANDIR)
 	for f in $(IPSEC_CMANS) ; \
 	do \
-		$(INSTALL) $(PUB) $$f $(CMANDIR)/ipsec_$$f || exit 1 ; \
-		./manlink $(CMANDIR) ipsec_$$f ; \
+		$(INSTALL) $(PUB) $$f $(PREFIX)/$(CMANDIR)/ipsec_$$f || exit 1 ; \
+		./manlink $(PREFIX)/$(CMANDIR) ipsec_$$f ; \
 	done
-	test -f $(CONFDIR)/ipsec.secrets || \
-		$(INSTALL) $(PRIV) secrets.eg $(CONFDIR)/ipsec.secrets
-	test -f $(CONFDIR)/ipsec.conf || \
-		$(INSTALL) $(PUB) conf.eg $(CONFDIR)/ipsec.conf
+	test -d $(PREFIX)/$(CONFDIR) || $(INSTALL) -d $(PREFIX)/$(CONFDIR)
+	test -f $(PREFIX)/$(CONFDIR)/ipsec.secrets || \
+		$(INSTALL) $(PRIV) secrets.eg $(PREFIX)/$(CONFDIR)/ipsec.secrets
+	test -f $(PREFIX)/$(CONFDIR)/ipsec.conf || \
+		$(INSTALL) $(PUB) conf.eg $(PREFIX)/$(CONFDIR)/ipsec.conf
 	# main copy must go in RCDIR, PRIVDIR may not be mounted at boot time
-	mkdir -p $(RCDIR)
-	$(INSTALL) setup $(RCDIR)/ipsec
-	rm -f $(PRIVDIR)/setup
-	ln -s $(REALRCDIR)/ipsec $(PRIVDIR)/setup
-	if test " $(DESTDIR)" != " " ; \
-	then : do nothing ; \
-	elif which chkconfig >/dev/null 2>&1 ; \
+	test -d $(PREFIX)/$(RCDIR) || mkdir -p $(PREFIX)/$(RCDIR)
+	$(INSTALL) setup $(PREFIX)/$(RCDIR)/ipsec
+	rm -f $(PREFIX)/$(PRIVDIR)/setup
+	ln -s $(PREFIX)/$(REALRCDIR)/ipsec $(PREFIX)/$(PRIVDIR)/setup
+	# Only turn on the service if doing default install
+	if [ $(PREFIX) = '/' ] ; then \
+		if which chkconfig >/dev/null 2>&1 ; \
 	then chkconfig --add ipsec ; \
 	else $(MAKE) setup4 ; \
+		fi ; \
 	fi
 
+
 setup4:	$(RCDIR)/ipsec
 	# fallback rc install -- on in run states 2345, off in 016
-	-cd $(RCDIR)/../rc0.d ; ln -s ../init.d/ipsec K35ipsec
-	-cd $(RCDIR)/../rc1.d ; ln -s ../init.d/ipsec K35ipsec
-	-cd $(RCDIR)/../rc2.d ; ln -s ../init.d/ipsec S35ipsec
-	-cd $(RCDIR)/../rc3.d ; ln -s ../init.d/ipsec S35ipsec
-	-cd $(RCDIR)/../rc4.d ; ln -s ../init.d/ipsec S35ipsec
-	-cd $(RCDIR)/../rc5.d ; ln -s ../init.d/ipsec S35ipsec
-	-cd $(RCDIR)/../rc6.d ; ln -s ../init.d/ipsec K35ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc0.d ; ln -s ../init.d/ipsec K35ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc1.d ; ln -s ../init.d/ipsec K35ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc2.d ; ln -s ../init.d/ipsec S35ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc3.d ; ln -s ../init.d/ipsec S35ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc4.d ; ln -s ../init.d/ipsec S35ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc5.d ; ln -s ../init.d/ipsec S35ipsec
+	-test -d $(RCDIR) && cd $(RCDIR)/../rc6.d ; ln -s ../init.d/ipsec K35ipsec
 
 clean:
 	rm -f *.o $(BINS) $(GENDFILES) $(GENDSCRIPTS) $(LOCALS)
diff -bruN freeswan-1.9.orig/utils/_confread freeswan-1.9/utils/_confread
--- freeswan-1.9.orig/utils/_confread	Wed Mar 14 19:05:54 2001
+++ freeswan-1.9/utils/_confread	Mon Jun  4 10:40:36 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: _confread,v 1.33.2.4 2001/03/15 00:05:54 henry Exp $
+# RCSID $Id: _confread,v 1.39 2001/06/01 15:49:13 henry Exp $
 #
 # Extract configuration info from /etc/ipsec.conf, repackage as assignments
 # to shell variables or tab-delimited fields.  Success or failure is reported
@@ -47,6 +47,7 @@
 fieldfmt=yes
 prefix=
 search=
+me="ipsec _confread"
 
 for dummy
 do
@@ -58,6 +59,7 @@
 			prefix="$2"
 			shift			;;
 	--search)	search="$2" ; shift	;;
+	--version)      echo "$me $IPSEC_VERSION" ; exit 0      ;;
 	--)		shift ; break		;;
 	-*)		echo "$0: unknown option \`$1'" >&2 ; exit 2	;;
 	*)		break			;;
@@ -115,10 +117,11 @@
 			fail("invalid section name " bq na[i] eq)
 	}
 
-	good = "also type auto authby"
+	good = "also type auto authby force_encrypt_cypher"
 	left = " left leftsubnet leftnexthop leftfirewall leftupdown"
 	akey = " keyexchange auth pfs keylife rekeymargin rekeyfuzz compress"
 	obs = " lifetime rekeystart rekeytries"
+	cert = " certfile keyfile peerfile certopts certpath"
 	akey = akey " keyingtries ikelifetime" obs
 	mkey = " spibase spi esp espenckey espauthkey espreplay_window"
 	left = left " leftespenckey leftespauthkey leftahkey"
@@ -126,7 +129,7 @@
 	mkey = mkey " ah ahkey ahreplay_window"
 	right = left
 	gsub(/left/, "right", right)
-	n = split(good left right akey mkey, g)
+	n = split(good left right akey mkey cert, g)
 	for (i = 1; i <= n; i++)
 		goodnames["conn:" g[i]] = 1
 
@@ -159,7 +162,9 @@
 function output(code, v1, v2) {
 	if (code == o_parm && v2 == "")		# suppress empty parameters
 		return
-	if (code == o_parm && !privatename(v1) && v2 ~ badchar)
+	if (privatename(v1))			# and private ones
+		return
+	if (code == o_parm && v2 ~ badchar)
 		fail("parameter value " bq v2 eq " contains unprintable character")
 
 	if (fieldfmt)
@@ -319,7 +324,7 @@
 			searchfound(sectionname)
 	} else {
 		# rather a kludge, but must check this somewhere
-		if (search == "auto" && rest !~ /^(add|start|ignore)$/)
+		if (search == "auto" && rest !~ /^(add|start|ignore|background)$/)
 			fail("illegal auto value " bq rest eq)
 	}
 	next
diff -bruN freeswan-1.9.orig/utils/_include freeswan-1.9/utils/_include
--- freeswan-1.9.orig/utils/_include	Tue Mar 14 19:38:50 2000
+++ freeswan-1.9/utils/_include	Mon Jun  4 10:42:33 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: _include,v 1.13 2000/03/15 00:38:50 henry Exp $
+# RCSID $Id: _include,v 1.14 2001/06/01 15:49:13 henry Exp $
 #
 # Output includes marker lines for file changes:
 #	"#< filename lineno" signals entry into that file
@@ -24,13 +24,14 @@
 # Lines which look like marker and report lines are never passed through.
 
 usage="Usage: $0 file ..."
+me="ipsec _include"
 
 for dummy
 do
 	case "$1" in
 	--inband)				;;	# back compatibility
 	--help)		echo "$usage" ; exit 0	;;
-	--version)	echo 1 ; exit 0		;;
+	--version)	echo "$me $IPSEC_VERSION" ; exit 0		;;
 	--)		shift ; break		;;
 	-*)		echo "$0: unknown option \`$1'" >&2 ; exit 2	;;
 	*)		break			;;
diff -bruN freeswan-1.9.orig/utils/_keycensor freeswan-1.9/utils/_keycensor
--- freeswan-1.9.orig/utils/_keycensor	Thu Jun  1 18:20:24 2000
+++ freeswan-1.9/utils/_keycensor	Mon Jun  4 10:42:45 2001
@@ -12,15 +12,16 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: _keycensor,v 1.5 2000/06/01 22:20:24 henry Exp $
+# RCSID $Id: _keycensor,v 1.6 2001/06/01 15:49:13 henry Exp $
 
 usage="Usage: $0 [file ...]"
+me="ipsec _keycensor"
 
 for dummy
 do
 	case "$1" in
 	--help)		echo "$usage" ; exit 0	;;
-	--version)	echo 1 ; exit 0		;;
+	--version)	echo "$me $IPSEC_VERSION" ; exit 0		;;
 	--)		shift ; break		;;
 	-*)		echo "$0: unknown option \`$1'" >&2 ; exit 2	;;
 	*)		break			;;
diff -bruN freeswan-1.9.orig/utils/_secretcensor freeswan-1.9/utils/_secretcensor
--- freeswan-1.9.orig/utils/_secretcensor	Thu Jun  1 18:19:52 2000
+++ freeswan-1.9/utils/_secretcensor	Mon Jun  4 10:42:55 2001
@@ -12,15 +12,16 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: _secretcensor,v 1.6 2000/06/01 22:19:52 henry Exp $
+# RCSID $Id: _secretcensor,v 1.7 2001/06/01 15:49:13 henry Exp $
 
 usage="Usage: $0 [file ...]"
+me="ipsec _secretcensor"
 
 for dummy
 do
 	case "$1" in
 	--help)		echo "$usage" ; exit 0	;;
-	--version)	echo 1 ; exit 0		;;
+	--version)	echo "$me $IPSEC_VERSION" ; exit 0		;;
 	--)		shift ; break		;;
 	-*)		echo "$0: unknown option \`$1'" >&2 ; exit 2	;;
 	*)		break			;;
diff -bruN freeswan-1.9.orig/utils/_updown freeswan-1.9/utils/_updown
--- freeswan-1.9.orig/utils/_updown	Tue Mar 27 15:53:31 2001
+++ freeswan-1.9/utils/_updown	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: _updown,v 1.11.2.2 2001/03/27 20:53:31 henry Exp $
+# RCSID $Id: _updown,v 1.14 2001/04/07 22:42:54 henry Exp $
 
 
 
@@ -57,8 +57,15 @@
 }
 doroute() {
 	parms="-net $PLUTO_PEER_CLIENT_NET netmask $PLUTO_PEER_CLIENT_MASK"
-	parms="$parms dev $PLUTO_INTERFACE gw $PLUTO_NEXT_HOP"
-	route $1 $parms
+	parms2="dev $PLUTO_INTERFACE gw $PLUTO_NEXT_HOP"
+	case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
+	"0.0.0.0/0.0.0.0")
+		# horrible kludge for obscure routing bug with opportunistic
+		route $1 -net 0.0.0.0 netmask 128.0.0.0 $parms2 &&
+			route $1 -net 128.0.0.0 netmask 128.0.0.0 $parms2
+		;;
+	*)	route $1 $parms $parms2	;;
+	esac
 	st=$?
 	if test $st -ne 0
 	then
@@ -74,15 +81,25 @@
 case "$PLUTO_VERB:$1" in
 prepare-host:*|prepare-client:*)
 	# delete possibly-existing route (preliminary to adding a route)
+	case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
+	"0.0.0.0/0.0.0.0")
+		# horrible kludge for obscure routing bug with opportunistic
+		parms1="-net 0.0.0.0 netmask 128.0.0.0"
+		parms2="-net 128.0.0.0 netmask 128.0.0.0"
+		oops="`route del $parms1 2>&1 ; route del $parms2 2>&1`"
+		;;
+	*)
 	parms="-net $PLUTO_PEER_CLIENT_NET netmask $PLUTO_PEER_CLIENT_MASK"
 	oops="`route del $parms 2>&1`"
+		;;
+	esac
 	status="$?"
 	if test " $oops" = " " -a " $status" != " 0"
 	then
 		oops="silent error, exit status $status"
 	fi
 	case "$oops" in
-	'SIOCDELRT: No such process')
+	'SIOCDELRT: No such process'*)
 		# This is what route (currently -- not documented!) gives
 		# for "could not find such a route".
 		oops=
diff -bruN freeswan-1.9.orig/utils/auto freeswan-1.9/utils/auto
--- freeswan-1.9.orig/utils/auto	Mon Feb  5 20:13:18 2001
+++ freeswan-1.9/utils/auto	Mon Jun  4 10:44:49 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: auto,v 1.55 2001/02/06 01:13:18 henry Exp $
+# RCSID $Id: auto,v 1.59 2001/05/04 05:31:50 henry Exp $
 
 me='ipsec auto'
 usage="Usage:
@@ -37,7 +37,7 @@
 do
 	case "$1" in
 	--help)		echo "$usage" ; exit 0	;;
-	--version)	echo 2 ; exit 0		;;
+	--version)      echo "$me $IPSEC_VERSION" ; exit 0      ;;
 	--show)		shopts=-x		;;
 	--showonly)	showonly=yes		;;
 	--config)	config="$2" ; shift	;;
@@ -222,11 +222,13 @@
 		return s[k]
 	}
 	function whackkey(dir,   rk) {
+		if (id(dir) == "%opportunistic")
+			return
 		rk = s[dir "rsasigkey"]
-		if (rk != "%dns")
-			print "ipsec whack --keyid", id(dir), "--pubkeyrsa", rk
-		else
+		if (rk == "%dns")
 			print "ipsec whack --keyid", id(dir)
+		else if (rk != "")
+			print "ipsec whack --keyid", id(dir), "--pubkeyrsa", rk
 	}
 	function output() {
 		if (!seensome)
@@ -288,8 +290,8 @@
 		}
 		duration("ikelifetime")
 
-		default("leftnexthop", s["right"])
-		default("rightnexthop", s["left"])
+		default("leftnexthop", "%direct")
+		default("rightnexthop", "%direct")
 		if (s["leftnexthop"] == s["left"])
 			fail("left and leftnexthop must not be the same")
 		if (s["rightnexthop"] == s["right"])
@@ -321,17 +323,56 @@
 			s["rightupdown"] = s["rightupdown"] " ipfwadm"
 
 		default("authby", "secret")
+		authbyfound = "0"
 		authtype = "--psk"
 		if (s["authby"] == "rsasig") {
+			authbyfound = "1"
 			authtype = "--rsasig"
 			need("leftrsasigkey")
 			need("rightrsasigkey")
-			if (id("left") ~ /^%/)
+			if (id("left") == "%any")
 				fail("ID \"" id("left") "\" cannot have RSA key")
-			if (id("right") ~ /^%/)
+			if (id("right") == "%any")
 				fail("ID \"" id("right") "\" cannot have RSA key")
-		} else if (s["authby"] != "secret")
+		}
+
+
+		if (s["authby"] == "cert") {
+			authbyfound = "1"
+			default("certfile", "")
+			default("certopts", "send")
+			default("keyfile", "")
+			default("certpath", "")
+			authtype = "--openssl"
+			need("certfile")
+			need("certopts")
+			need("keyfile")
+			need("certpath")
+		}
+
+		if (s["authby"] != "secret") {
+		  if (s["authby"] != "psk") {
+			if (authbyfound != "1") {
 			fail("unknown authby value \"" s["authby"] "\"")
+			}
+		  }
+		}
+
+		default("force_encrypt_cypher", "")
+		if ("force_encrypt_cypher" in s) {
+			if (s["force_encrypt_cypher"] == "des") {
+				force_encrypt_cypher = "des"
+			}
+			if (s["force_encrypt_cypher"] == "DES") {
+				force_encrypt_cypher = "des"
+			}
+			if (s["force_encrypt_cypher"] == "3des") {
+				force_encrypt_cypher = "3des"
+			}
+			if (s["force_encrypt_cypher"] == "3DES") {
+				force_encrypt_cypher = "3des"
+			}
+		}
 
 		settings = "--encrypt"
 		if (s["type"] != "transport")
@@ -366,6 +407,17 @@
 		if ("rekeyfuzz" in s)
 			fuzz = "--rekeyfuzz " s["rekeyfuzz"]
 
+		if (authtype == "--openssl") {
+			if ("certfile" in s)
+				certfile = "--certfile " s["certfile"]
+			if ("certopts" in s)
+				certopts = "--certopts " s["certopts"]
+			if ("keyfile" in s)
+				keyfile = "--keyfile " s["keyfile"]
+			if ("certpath" in s)
+				certpath = "--certpath " s["certpath"]
+		}
+
 		print "ipsec whack --name", name, settings, "\\"
 		print "\t--host", s["left"], lc,
 				"--nexthop", s["leftnexthop"], lud, lid, "\\"
@@ -373,8 +425,23 @@
 				"--nexthop", s["rightnexthop"], rud, rid, "\\"
 		print "\t--ipseclifetime", s["keylife"],
 			"--rekeywindow", s["rekeymargin"], "\\"
+		if (authtype == "--openssl") {
+			if (certfile != "--certfile ")
+				print certfile, "\\"
+			if (certopts != "--certopts ")
+				print certopts, "\\"
+			if (keyfile != "--keyfile ")
+				print keyfile, "\\"
+			if (certpath != "--certpath ")
+				print certpath, "\\"
+		}
+
+		if (force_encrypt_cypher != "") {
+			print "\t--force_encrypt_cypher", s["force_encrypt_cypher"], "\\"
+		}
+
 		print "\t--keyingtries", s["keyingtries"], fuzz
-		if (authtype != "--psk") {
+		if (authtype == "--rsasig") {
 			whackkey("left")
 			whackkey("right")
 		}
diff -bruN freeswan-1.9.orig/utils/barf freeswan-1.9/utils/barf
--- freeswan-1.9.orig/utils/barf	Mon Dec 11 09:51:45 2000
+++ freeswan-1.9/utils/barf	Mon Jun  4 10:45:44 2001
@@ -12,15 +12,21 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: barf,v 1.45 2000/12/11 14:51:45 henry Exp $
+# RCSID $Id: barf,v 1.47 2001/06/01 15:49:13 henry Exp $
 
 KERNSRC=${KERNSRC-/usr/src/linux}
 LOGS=${LOGS-/var/log}
+me="ipsec barf"
 
 # message patterns that start relevant parts of logs
 fstart='Starting FreeS.WAN'
 pstart='Starting Pluto'
 
+case "$1" in
+--help)		echo "Usage: ipsec barf" ; exit 0	;;
+--version)	echo "$me $IPSEC_VERSION" ; exit 0	;;
+esac
+
 # make sure output is in English
 unset LANG LANGUAGE LC_ALL LC_MESSAGES
 
@@ -32,7 +38,7 @@
 	# try the suggested files first
 	for f in $*
 	do
-		if test -r $LOGS/$f && egrep -q "$s" $LOGS/$f
+		if test -r $LOGS/$f -a ! -d $LOGS/$f && egrep -q "$s" $LOGS/$f
 		then
 			# aha, this one has it
 			findlog_result=$LOGS/$f
@@ -42,7 +48,7 @@
 	# nope, resort to a search, newest first, of uncompressed logs
 	for f in `ls -t $LOGS | egrep -v '\.(gz|Z)$'`
 	do
-		if test -r $LOGS/$f && egrep -q "$s" $LOGS/$f
+		if test -r $LOGS/$f -a ! -d $LOGS/$f && egrep -q "$s" $LOGS/$f
 		then
 			# found it
 			findlog_result=$LOGS/$f
@@ -103,11 +109,11 @@
 _________________________
 ipsec _include /etc/ipsec.secrets | ipsec _secretcensor
 _________________________
-ls -l ${IPSECDIR-/usr/local/lib/ipsec}
+ls -l ${IPSEC_DIR-/usr/local/lib/ipsec}
 _________________________
-for f in `ls ${IPSECDIR-/usr/local/lib/ipsec} | egrep updown`
+for f in `ls ${IPSEC_DIR-/usr/local/lib/ipsec} | egrep updown`
 do
-	cat ${IPSECDIR-/usr/local/lib/ipsec}/$f
+	cat ${IPSEC_DIR-/usr/local/lib/ipsec}/$f
 done
 _________________________
 cat /proc/net/dev
diff -bruN freeswan-1.9.orig/utils/conf.proto freeswan-1.9/utils/conf.proto
--- freeswan-1.9.orig/utils/conf.proto	Sun Dec  3 17:16:23 2000
+++ freeswan-1.9/utils/conf.proto	Mon Jun  4 10:46:06 2001
@@ -1,8 +1,8 @@
 # /etc/ipsec.conf - FreeS/WAN IPsec configuration file
-# RCSID $Id: conf.proto,v 1.28 2000/12/03 22:16:23 henry Exp $
+# RCSID $Id: conf.proto,v 1.29 2001/06/01 17:55:20 henry Exp $
 
 # More elaborate and more varied sample configurations can be found
-# in FreeS/WAN's doc/examples file.
+# in FreeS/WAN's doc/examples file, and in the HTML documentation.
 
 
 
@@ -26,12 +26,6 @@
 conn %default
 	# How persistent to be in (re)keying negotiations (0 means very).
 	keyingtries=0
-	# Parameters for manual-keying testing (DON'T USE OPERATIONALLY).
-	# Note:  only one test connection at a time can use these parameters!
-	spi=0x200
-	esp=3des-md5-96
-	espenckey=0x01234567_89abcdef_02468ace_13579bdf_12345678_9abcdef0
-	espauthkey=0x12345678_9abcdef0_2468ace0_13579bdf
 	# RSA authentication with keys from DNS.
 	authby=rsasig
 	leftrsasigkey=%dns
@@ -39,7 +33,17 @@
 
 
 
-# sample connection
+# connection description for (experimental!) opportunistic encryption
+# (requires KEY record in your DNS reverse map; see doc/opportunism.howto)
+conn me-to-anyone
+	left=%defaultroute
+	right=%opportunistic
+	# uncomment to enable incoming; change to auto=route for outgoing
+	#auto=add
+
+
+
+# sample VPN connection
 conn sample
 	# Left security gateway, subnet behind it, next hop toward right.
 	left=10.0.0.1
diff -bruN freeswan-1.9.orig/utils/errcheck freeswan-1.9/utils/errcheck
--- freeswan-1.9.orig/utils/errcheck	Wed Sep 20 10:31:50 2000
+++ freeswan-1.9/utils/errcheck	Mon Jun  4 10:46:19 2001
@@ -12,13 +12,15 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: errcheck,v 1.6 2000/09/20 14:31:50 henry Exp $
+# RCSID $Id: errcheck,v 1.9 2001/05/24 01:22:37 henry Exp $
 
 # the errors.[och] stuff is for math emulation
 # the HiSax nonsense is due to a Red Hat 5.2 botch
-oops="`sed '/errors*\.[och]/s/errors*\./eror./g' $* |
-		sed '/#error .HiSax: No cards configured/s/error/eror/' |
-		egrep -i 'error|\*\*\*'`"
+# Red Hat's 2.2.19 whines about function read_rx_long_length_errors in e100.c
+oops="`sed -e '/errors*\.[och]/s/errors*\./eror./g' \
+	   -e '/#error .HiSax: No cards configured/s/error/eror/' \
+	   -e '/^e100.c: In function/s/length_errors/length_erors/' $* |
+	egrep -i 'error|\*\*\*' | egrep -v ': warning:'`"
 if test " $oops" != " "
 then
 	echo
diff -bruN freeswan-1.9.orig/utils/fswcert-0.4/Makefile freeswan-1.9/utils/fswcert-0.4/Makefile
--- freeswan-1.9.orig/utils/fswcert-0.4/Makefile	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/utils/fswcert-0.4/Makefile	Wed May 16 10:57:20 2001
@@ -0,0 +1,26 @@
+###################################################
+# Adjust SSLDIR before make ...
+SSLDIR=/usr/ssl
+
+# Adjust IPSECDIR before make install ...
+IPSECDIR=/usr/lib/ipsec
+###################################################
+
+VERSION = 0.4
+
+CFLAGS = -g -Wall -O2 -DVERSION=\"$(VERSION)\" -I$(SSLDIR)/include -I$(OPENSSLROOT)/include
+LDFLAGS = -g -L$(SSLDIR)/lib -L$(OPENSSLROOT)/lib
+LDLIBS = -lcrypto
+
+DISTFILES=Makefile README fswcert.c _confread.patch
+
+all : fswcert
+
+fswcert : fswcert.o
+	$(CC) $(LDFLAGS) -o fswcert fswcert.o $(LDLIBS)
+
+fswcert.o: fswcert.c
+	$(CC) $(CFLAGS) -c fswcert.c
+
+clean :
+	rm -f fswcert fswcert.o
diff -bruN freeswan-1.9.orig/utils/fswcert-0.4/README freeswan-1.9/utils/fswcert-0.4/README
--- freeswan-1.9.orig/utils/fswcert-0.4/README	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/utils/fswcert-0.4/README	Wed May 16 10:57:20 2001
@@ -0,0 +1,94 @@
+fswcert Utility
+===============
+
+
+This replaces the grabkey and grabsubject utilities from the
+FreeS/WAN X.509 patch, and supports the new configuration
+options leftcert=... and rightcert=...
+
+Dependencies:
+  fswcert requires the openssl 0.9.5a package.
+
+Bugs:
+  Due to openssl, the fswcert binary is HUGE.
+
+
+These are the options supported:
+--------------------------------
+
+-c --certificate	print certificate data
+
+	Prints the certificate data needed for FreeS/WAN's
+	ipsec.conf. Input can be from an X.509 file in PEM
+	or DER format, or from a PKCS12 (*.p12) file.
+
+-k --key	print private RSA key data
+
+	Prints the private key data needed for FreeS/WAN's
+	ipsec.secrets. Input can be from an RSA private key
+	file, or from a PKCS12 (*.p12) file.
+
+-l --left	left-side parameters for ipsec.conf
+
+	Prefix certificate data with `left'
+
+-r --right	right-side parameters for ipsec.conf
+
+	Prefix certificate data with `left'
+
+--type=[x509|rsa|pkcs12]	select input file type
+
+	Select input file type. Defaults to x509.
+
+--format=[PEM|DER]	select input file format
+
+	Select input file format. Defaults to PEM.
+
+-C --directory=dir	change into dir first
+
+	Change into dir at startup. (Files are then
+	read relative to this directory).
+
+-q --quiet	single line error messages to stdout
+
+	This is a hack to better integrate with _confread.
+	Don't use manually.
+
+-d --der-output		outputs DN in DER binary format
+
+	This is also a hack. Useful to give the CA the DN in DER
+	so that it can insert the 'subject' search field in its
+	LDAP tables. 
+
+-v --version	returns version of fswcert
+
+Either --key or --certificate is required. It makes no sense to
+specify both --left and --right; the last option wins.
+
+
+To use X.509 PEM-encoded certificates with FreeS/WAN directly, do this:
+-----------------------------------------------------------------------
+
+- Adjust the IPSECDIR and SSLDIR in Makefile
+
+- Build fswcert with `make'
+
+- Install fswcert with `make install'
+
+- Patch FreeS/WAN's _confread with the patch provided
+
+- Put all the certificates you want to use with FreeS/WAN
+  in the /etc/ipsec.d/ directory
+
+
+Then you can use these new options in ipsec.conf and includes:
+--------------------------------------------------------------
+
+leftcert=filename.pem
+	Reads the identity and public key from filename.pem
+	(Replaces both leftid=@~... and leftrsasigkex=0x...)
+
+rightcert=filename.pem
+	Reads the identity and public key from filename.pem
+	(Replaces both rightid=@~... and rightrsasigkex=0x...)
+
